﻿// CodeGear C++Builder
// Copyright (c) 1995, 2015 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'vCal.pas' rev: 29.00 (Windows)

#ifndef VcalHPP
#define VcalHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.Classes.hpp>
#include <System.SysUtils.hpp>
#include <Winapi.Windows.hpp>

//-- user supplied -----------------------------------------------------------

namespace Vcal
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TvTimeZoneOffset;
class DELPHICLASS TvTimeZone;
class DELPHICLASS TvEvent;
class DELPHICLASS TvEventCollection;
class DELPHICLASS TvCalendar;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TvEventStatus : unsigned char { esAccepted, esNeedsAction, esSent, esTentative, esConfirmed, esDeclined, esCompleted, esDelegated };

enum DECLSPEC_DENUM TvCalenderVersion : unsigned char { vv1, vv2 };

enum DECLSPEC_DENUM TvEventTransp : unsigned char { etFree, etNotFree, etOther };

enum DECLSPEC_DENUM TvEventClass : unsigned char { ecPublic, ecPrivate, ecConfidential };

enum DECLSPEC_DENUM TvEventCategory : unsigned char { caAppointment, caBusiness, caEducation, caHoliday, caMeeting, caMiscellaneous, caPersonal, caPhonecall, caSickDay, caSpecialOccasion, caTravel, caVacation };

enum DECLSPEC_DENUM TEventProperty : unsigned char { epDTStart, epDTEnd, epStatus, epPriority, epSummary, epTransp, epDescription, epURL, epUID, epLocation, epClass, epCategories, epResources, epRecurrency };

typedef System::Set<TvEventCategory, TvEventCategory::caAppointment, TvEventCategory::caVacation> TvEventCategories;

class PASCALIMPLEMENTATION TvTimeZoneOffset : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	int FOffsetFrom;
	System::TDateTime FDTStart;
	int FOffsetTo;
	System::UnicodeString FName;
	
public:
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	
__published:
	__property int OffsetFrom = {read=FOffsetFrom, write=FOffsetFrom, nodefault};
	__property int OffsetTo = {read=FOffsetTo, write=FOffsetTo, nodefault};
	__property System::TDateTime DTStart = {read=FDTStart, write=FDTStart};
	__property System::UnicodeString Name = {read=FName, write=FName};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TvTimeZoneOffset(void) { }
	
public:
	/* TObject.Create */ inline __fastcall TvTimeZoneOffset(void) : System::Classes::TPersistent() { }
	
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION TvTimeZone : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	TvCalendar* FOwner;
	System::UnicodeString FID;
	TvTimeZoneOffset* FDayLight;
	System::UnicodeString FURL;
	TvTimeZoneOffset* FStandard;
	void __fastcall SetDaylight(TvTimeZoneOffset* const Value);
	void __fastcall SetStandard(TvTimeZoneOffset* const Value);
	
public:
	__fastcall TvTimeZone(TvCalendar* Owner);
	__fastcall virtual ~TvTimeZone(void);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	System::UnicodeString __fastcall ToXml(void);
	void __fastcall LoadFromXml(System::UnicodeString XMLData);
	
__published:
	__property System::UnicodeString ID = {read=FID, write=FID};
	__property System::UnicodeString URL = {read=FURL, write=FURL};
	__property TvTimeZoneOffset* Standard = {read=FStandard, write=SetStandard};
	__property TvTimeZoneOffset* Daylight = {read=FDayLight, write=SetDaylight};
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TvEvent : public System::Classes::TCollectionItem
{
	typedef System::Classes::TCollectionItem inherited;
	
private:
	System::TDateTime FDTEnd;
	System::TDateTime FDTStart;
	int FPriority;
	TvEventStatus FStatus;
	System::UnicodeString FSummary;
	TvEventTransp FTrans;
	System::Classes::TStrings* FDescription;
	System::UnicodeString FURL;
	System::UnicodeString FUID;
	System::UnicodeString FLocation;
	TvEventClass FClass;
	TvEventCategories FCategories;
	System::Classes::TStrings* FResources;
	System::UnicodeString FAlarmMessage;
	System::TDateTime FAlarmTime;
	System::UnicodeString FRecurrency;
	TvTimeZone* FvTimeZone;
	void __fastcall SetDTEnd(const System::TDateTime Value);
	void __fastcall SetDTStart(const System::TDateTime Value);
	void __fastcall SetPriority(const int Value);
	void __fastcall SetStatus(const TvEventStatus Value);
	void __fastcall SetSummary(const System::UnicodeString Value);
	void __fastcall SetTransp(const TvEventTransp Value);
	void __fastcall SetDescription(System::Classes::TStrings* const Value);
	void __fastcall SetUID(const System::UnicodeString Value);
	void __fastcall SetURL(const System::UnicodeString Value);
	void __fastcall SetLocation(const System::UnicodeString Value);
	void __fastcall SetClass(const TvEventClass Value);
	void __fastcall SetCategories(const TvEventCategories Value);
	void __fastcall SetResources(System::Classes::TStrings* const Value);
	void __fastcall SetRecurrency(const System::UnicodeString Value);
	void __fastcall SetvTimeZone(TvTimeZone* const Value);
	
public:
	__fastcall virtual TvEvent(System::Classes::TCollection* Collection);
	__fastcall virtual ~TvEvent(void);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	
__published:
	__property System::UnicodeString AlarmMessage = {read=FAlarmMessage, write=FAlarmMessage};
	__property System::TDateTime AlarmTime = {read=FAlarmTime, write=FAlarmTime};
	__property TvEventCategories Categories = {read=FCategories, write=SetCategories, nodefault};
	__property TvEventClass Classification = {read=FClass, write=SetClass, nodefault};
	__property System::Classes::TStrings* Description = {read=FDescription, write=SetDescription};
	__property System::TDateTime DTEnd = {read=FDTEnd, write=SetDTEnd};
	__property System::TDateTime DTStart = {read=FDTStart, write=SetDTStart};
	__property System::UnicodeString Location = {read=FLocation, write=SetLocation};
	__property int Priority = {read=FPriority, write=SetPriority, nodefault};
	__property System::UnicodeString Recurrency = {read=FRecurrency, write=SetRecurrency};
	__property System::Classes::TStrings* Resources = {read=FResources, write=SetResources};
	__property TvEventStatus Status = {read=FStatus, write=SetStatus, nodefault};
	__property System::UnicodeString Summary = {read=FSummary, write=SetSummary};
	__property TvEventTransp Transp = {read=FTrans, write=SetTransp, nodefault};
	__property System::UnicodeString URL = {read=FURL, write=SetURL};
	__property System::UnicodeString UID = {read=FUID, write=SetUID};
	__property TvTimeZone* vTimeZone = {read=FvTimeZone, write=SetvTimeZone};
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION TvEventCollection : public System::Classes::TCollection
{
	typedef System::Classes::TCollection inherited;
	
public:
	TvEvent* operator[](int Index) { return Items[Index]; }
	
private:
	TvCalendar* FOwner;
	TvEvent* __fastcall GetvEvent(int Index);
	void __fastcall SetvEvent(int Index, TvEvent* const Value);
	
public:
	__fastcall TvEventCollection(TvCalendar* AOwner);
	HIDESBASE TvEvent* __fastcall Add(void);
	HIDESBASE TvEvent* __fastcall Insert(int Index);
	__property TvEvent* Items[int Index] = {read=GetvEvent, write=SetvEvent/*, default*/};
	DYNAMIC System::Classes::TPersistent* __fastcall GetOwner(void);
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TvEventCollection(void) { }
	
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TvCalendar : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	TvEventCollection* FvEvents;
	System::UnicodeString FProdID;
	System::UnicodeString FTimeZone;
	TvTimeZone* FvTimeZone;
	TvCalenderVersion FvCalendarVersion;
	TvEventCollection* __fastcall GetvEvents(void);
	void __fastcall SetvEvents(TvEventCollection* const Value);
	System::UnicodeString __fastcall GetVersion(void);
	void __fastcall SetVersion(const System::UnicodeString Value);
	int __fastcall GetVersionNr(void);
	void __fastcall SetTimeZone(TvTimeZone* const Value);
	
public:
	__fastcall virtual TvCalendar(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TvCalendar(void);
	void __fastcall LoadFromStream(System::Classes::TStream* Stream);
	void __fastcall InsertFromStream(System::Classes::TStream* Stream);
	void __fastcall SaveToStream(System::Classes::TStream* Stream);
	void __fastcall LoadFromFile(const System::UnicodeString FileName);
	void __fastcall InsertFromFile(const System::UnicodeString FileName);
	void __fastcall SaveToFile(const System::UnicodeString FileName);
	__property TvTimeZone* vTimeZone = {read=FvTimeZone, write=SetTimeZone};
	
__published:
	__property TvEventCollection* vEvents = {read=GetvEvents, write=SetvEvents};
	__property System::UnicodeString ProdID = {read=FProdID, write=FProdID};
	__property System::UnicodeString TimeZone = {read=FTimeZone, write=FTimeZone};
	__property TvCalenderVersion vCalendarVersion = {read=FvCalendarVersion, write=FvCalendarVersion, default=0};
	__property System::UnicodeString Version = {read=GetVersion, write=SetVersion};
};


//-- var, const, procedure ---------------------------------------------------
static const System::Int8 MAJ_VER = System::Int8(0x1);
static const System::Int8 MIN_VER = System::Int8(0x2);
static const System::Int8 REL_VER = System::Int8(0x0);
static const System::Int8 BLD_VER = System::Int8(0x0);
extern DELPHI_PACKAGE System::UnicodeString __fastcall EventClassToStr(TvEventClass Value);
extern DELPHI_PACKAGE TvEventClass __fastcall StrToEventClass(System::UnicodeString Value);
extern DELPHI_PACKAGE System::UnicodeString __fastcall EventPropertyToString(TEventProperty Value);
extern DELPHI_PACKAGE TEventProperty __fastcall StringToEventProperty(System::UnicodeString Value);
extern DELPHI_PACKAGE System::UnicodeString __fastcall EventStatusToString(TvEventStatus Value);
extern DELPHI_PACKAGE TvEventStatus __fastcall StringToEventStatus(System::UnicodeString Value);
extern DELPHI_PACKAGE TvEventCategory __fastcall StrToEventCategory(System::UnicodeString Value);
extern DELPHI_PACKAGE System::UnicodeString __fastcall EventCategoryToStr(TvEventCategory Category);
extern DELPHI_PACKAGE System::UnicodeString __fastcall StatusToStr(TvEventStatus AStatus);
}	/* namespace Vcal */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_VCAL)
using namespace Vcal;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VcalHPP
